/*
 * lcdc.h
 *
 *  Created on: 2013/04/24
 *  Copyright(C) 2013 Ryoichi Yokomizu
 *  All rights reserved
 */

#ifndef LCDC_H_
#define LCDC_H_

/* LCDC_Init()のパラメータ */
#define LCDC_MODE_UNKNOWN	0x00
#define LCDC_MODE_RGB888	0x01
#define LCDC_MODE_RGB565	0x02
#define LCDC_MODE_LUT8		0x03

/* LCDCと内蔵周辺デバイスの初期化 */
void LCDC_Init(unsigned char mode);

/* 表示クリア */
void LCDC_ClearScreen(void);

/* 描画関数 */
void LCDC_BoxFill(short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void LCDC_BitBlt(short x, short y, short width, short height, short srcx, short srcy);
void LCDC_HLine(short x1, short y1, short x2, unsigned char r, unsigned char g, unsigned char b);
void LCDC_VLine(short x1, short y1, short y2, unsigned char r, unsigned char g, unsigned char b);
void LCDC_Rectangle(short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void LCDC_Line(short x1, short y1, short x2, short y2, unsigned char r, unsigned char g, unsigned char b);
void LCDC_Circle(short cx, short cy, short rn, unsigned char r, unsigned char g, unsigned char b);
void LCDC_CircleFill(short cx, short cy, short rn, unsigned char r, unsigned char g, unsigned char b);
void LCDC_SetPixel(short x1, short y1, unsigned char r, unsigned char g, unsigned char b);
void LCDC_GetPixel(short x1, short y1, unsigned char *pr, unsigned char *pg, unsigned char *pb);
void LCDC_DrawFont(short x1, short y1, short xmag, short ymag, unsigned char code, unsigned char r, unsigned char g, unsigned char b);
void LCDC_DrawString(short x1, short y1, short xmag, short ymag, char *pstring, unsigned char r, unsigned char g, unsigned char b);
void LCDC_Scroll(short h, short v);

/* VDISP期間待ち(チラ付き防止用) */
void LCDC_WaitVdisp(void);

/* フレームバッファ設定（現在利用していないため非公開API） */
void LCDC_SetFrameStartAddress(unsigned long addr);
unsigned long LCDC_GetFrameStartAddress(void);

/* LCDCレジスタ書き込み(16bit) */
/* extern void LCDC_WriteRegister16(unsigned long addr, unsigned short data);*/
/* ===>spi.cへ移動 */

/* LCDCレジスタ書き込み(24bit) */
/* extern void LCDC_WriteRegister24(unsigned long addr, unsigned long data);*/
/* ===>spi.cへ移動 */

/* LCDCレジスタ読み込み(16bit) */
/* extern unsigned short LCDC_ReadRegister16(unsigned long addr); */
/* ===>spi.cへ移動 */

/* 表示データ転送 */
/* void LCDC_BurstWrite(unsigned long addr, unsigned char* buf, unsigned long size); */
/* ===>spi.cへ移動 */

/* LCDCの情報を取得 */
unsigned short LCDC_GetBitsPerPixel(void);
unsigned short LCDC_GetScreenWidth(void);
unsigned short LCDC_GetScreenHeight(void);
unsigned short LCDC_GetImageFormat(void);

#endif /* LCDC_H_ */
